/* Application
*/
component
{
    this.name = 'ColdSpring2AOPFailure';
    this.applicationTimeout = 2777;
    this.sessionManagement = true;
    this.sessionTimeout = 1777;

    this.mappings['/coldspring'] = getDirectoryFromPath(getCurrentTemplatePath()) & 'coldspring';
    this.mappings['/org'] = getDirectoryFromPath(getCurrentTemplatePath()) & 'org';


    /* My orignal mapping that was breaking AOP for me:
    */
    this.mappings['/application'] = getDirectoryFromPath(getCurrentTemplatePath()); //  AOP fails

    /* Some quick tests of different mapping values and their results:
    */
    //this.mappings['/application'] = '';             // AOP works
    //this.mappings['/application'] = '\';            // AOP works
    //this.mappings['/application'] = 'asdf';         // AOP works
    //this.mappings['/application'] = 'D:\';          // AOP fails
    //this.mappings['/application'] = 'D:\foobar\';   // AOP works (directory nonexistant)
    //this.mappings['/application'] = 'D:\content\';  // AOP works (directory exists) - surprised at this one - i expected it to fail


    this.pseudoConstructor = {time=now(),tickcount=getTickCount()};    // replaced on every request


    function onApplicationStart()
    {
        application.start = {time=now(),tickcount=getTickCount()};     // this is persistent
        application.requestCount = 0;
        var properties = {};
        application.beanFactory = new coldspring.beans.xml.XmlBeanFactory(expandPath('ColdSpring2AOPFailure.xml'),properties);
    }/* onApplicationStart */


    function onRequestStart()
    {
        request.application = this; // this is the best way to get a reference to the application instance now
        application.timeAlive = dateDiff('s',application.start.time,this.pseudoConstructor.time);
        application.requestCount++;
    }/* onRequestStart */


}/* Application */
