<cfparam name="task" type="string" default="getBeans">

<cfoutput>
<!DOCTYPE html>
<html>
<head>
    <title>#application.applicationName#</title>
    <script type="text/javascript">
        <cfif task eq "restart">
            baseURL = location.protocol + '//' + location.hostname + ':' + location.port + location.pathname
            //alert(baseURL);
            window.location = baseURL;
        </cfif>
    </script>
</head>
<body>

    <h1><a href="?#rand()#">#application.applicationName#</a></h1>
    <p>
        <em>Served #application.requestCount# page(s) since #application.start.time#</em>
        <br />
        <em>This page served at #now()# #getTickCount()#</em>
    </p>

    <a href="?task=applicationStop">applicationStop</a>
    <a href="?task=onApplicationStart">onApplicationStart</a>
    <a href="?task=restart">restart</a>
    <br />
    <a href="?task=getBeans">getBeans</a>
    <a href="?task=reloadBeans">reloadBeans</a>


    <h2>Task: #task#</h2>
    <cfswitch expression="#task#">
        <cfcase value="applicationStop">
            <cfset applicationStop()>
        </cfcase>
        <cfcase value="onApplicationStart">
            <cfset request.application.onApplicationStart()>
        </cfcase>
        <cfcase value="restart">
            <cfset applicationStop()>
        </cfcase>

        <cfcase value="getBeans">
            <cfdump var="#application.beanFactory#">
            <p>#application.beanFactory.getVersion()#</p>

            <cfset beanNameArray = application.beanFactory.getBeanDefinitionNames()>
            <cfdump var="#beanNameArray#">

            <cfloop from="1" to="#arrayLen(beanNameArray)#" index="i">
                <cfset beanName = beanNameArray[i]>
                <h3>#beanName#</h3>

                <cfset beanDef = application.beanFactory.getBeanDefinition(beanName)>

                <cfif beanDef.isAbstract()>
                    <em>Abstract</em>
                <cfelse>
                    <cfdump var="#application.beanFactory.getBean(beanName)#">
                </cfif>
            </cfloop>
        </cfcase>
        <cfcase value="reloadBeans">

            <cfset structDelete(application,'beanfactory')>
            <cfset properties = {}>
            <cfset application.beanFactory = new coldspring.beans.xml.XmlBeanFactory(expandPath('ColdSpring2AOPFailure.xml'),properties)>

        </cfcase>
        <cfdefaultcase>
        </cfdefaultcase>
    </cfswitch>


    <hr/>
    <hr/>
    <strong>Application</strong>
    <cfdump var="#application#">
    <strong>Request</strong>
    <cfdump var="#request#">

</body>
</html>
</cfoutput>
